<template>
    <div>
        <h1 class="mt-5 mb-4 pb-2 text-uppercase text-center">
            Consulta de Séries Históricas de Preço
        </h1>

        <div class="container-sm">
            <div class="form-group mb-4">
                <label for="produto">Produto</label>
                <select id="produto" class="form-control" name="produto"
                        v-bind:class="{ 'is-invalid': this.submitted && !isProdutoValid() }"
                        v-model="produto">
                    <option v-if="!produtos" value="null" disabled hidden>
                        Carregando produtos...
                    </option>
                    <option v-if="produtos && produtos.length !== 0"
                            value="null" disabled hidden>
                        Selecione um produto
                    </option>
                    <option v-if="produtos && produtos.length === 0"
                            value="null" disabled hidden>
                        Nenhum produto disponível
                    </option>
                    <option v-for="produto in produtos" v-bind:value="produto">
                        {{ produto.nome }}
                    </option>
                </select>
                <div class="invalid-feedback">
                    É preciso selecionar um produto.
                </div>
            </div>

            <div class="form-group mb-4">
                <label for="municipio">Municípios</label>
                <multi-select
                        id="municipio"
                        v-model="municipiosSelecionados"
                        class="form-control p-0"
                        v-bind:class="{ 'is-invalid': this.submitted && !isMunicipioValid() }"
                        :options="options"
                        :btnLabel="labelMunicipios"
                        :selectOptions="municipiosOpcoes"/>
                <div class="invalid-feedback">
                    É preciso selecionar pelo menos um município.
                </div>
            </div>

            <div class="form-group mb-4">
                <label for="ano_inicial">Ano Inicial</label>
                <select id="ano_inicial"
                        class="form-control"
                        v-bind:class="{ 'is-invalid': this.submitted && !isAnoInicialValid() }"
                        name="ano_inicial"
                        v-model="anoInicial">
                    <option v-for="ano in anosLevantamento" v-bind:value="ano">
                        {{ ano }}
                    </option>
                </select>
                <div class="invalid-feedback">
                    O ano inicial deve ser menor ou igual o ano final.
                </div>
            </div>

            <div class="form-group mb-4">
                <label for="ano_final">Ano Final</label>
                <select id="ano_final" class="form-control" name="ano_final" v-model="anoFinal">
                    <option v-for="ano in anosLevantamento" v-bind:value="ano">
                        {{ ano }}
                    </option>
                </select>
            </div>

            <div class="form-group">
                <label>Período</label><br/>
                <label class="mr-3"><input type="radio" value="anual" v-model="periodo" class="mr-2"/>
                    Anual
                </label>
                <label class="mr-3"><input type="radio" value="mensal" v-model="periodo" class="mr-2"/>
                    Mensal
                </label>
                <label class="mr-3"><input type="radio" value="semanal" v-model="periodo" class="mr-2"/>
                    Semanal
                </label>
            </div>

            <div class="form-group">
                <label>Visualizar dados como</label><br/>
                <label class="mr-3"><input type="radio" value="html" v-model="tipo" class="mr-2"/>
                    HTML
                </label>
                <label class="mr-3"><input type="radio" value="csv" v-model="tipo" class="mr-2"/>
                    CSV
                </label>
            </div>

            <button type="button" class="btn btn-dark btn-md mt-4 d-block mx-auto" v-on:click="consultar">
                Consultar
            </button>
        </div>

        <div v-if="loaded" class="my-5">
            <table v-if="tipo === 'html' && resultados.length" class="mx-auto">
                <thead>
                <tr>
                    <th v-for="campo in Object.keys(resultados[0])">{{ campo }}</th>
                </tr>
                </thead>
                <tbody>
                <tr v-for="resultado in resultados">
                    <td v-for="campo in resultado">{{ campo }}</td>
                </tr>
                </tbody>
            </table>

            <h4 v-if="resultados.length === 0" class="text-center">Nenhum resultado encontrado.</h4>
        </div>
    </div>
</template>

<script>
    import {mapState} from 'vuex'
    import multiSelect from 'vue-multi-select';
    import 'vue-multi-select/dist/lib/vue-multi-select.min.css';

    export default {
        mounted() {
            const anoAtual = (new Date()).getFullYear()
            this.anoInicial = anoAtual
            this.anoFinal = anoAtual
        },
        computed: {
            labelMunicipios() {
                const quantidadeSelecionados = this.municipiosSelecionados.length;
                if (quantidadeSelecionados === 0) {
                    return 'Selecione um município'
                } else if (quantidadeSelecionados === 1) {
                    return this.municipiosSelecionados[0].name
                } else if (quantidadeSelecionados === this.municipiosOpcoes.length) {
                    return "Todos os municípios"
                }

                return 'Municípios'
            },
            municipiosOpcoes() {
                return this.municipios.map(municipio => {
                    return {
                        name: municipio.nome,
                        municipio: municipio,
                    }
                })
            },
            ...mapState([
                'municipios',
                'produtores',
                'produtos',
                'anosLevantamento',
            ]),
        },
        data() {
            return {
                submitted: false,
                loaded: false,
                produto: null,
                anoInicial: null,
                anoFinal: null,
                periodo: 'mensal',
                tipo: 'html',
                resultados: [],
                municipiosSelecionados: [],
                options: {
                    multi: true,
                    cssSelected: option => (option.selected ? { 'color': '#429488' } : ''),
                },
            }
        },
        methods: {
            isProdutoValid() {
                return this.produto
            },
            isMunicipioValid() {
                return this.municipiosSelecionados.length !== 0
            },
            isAnoInicialValid() {
                return this.anoInicial && this.anoInicial <= this.anoFinal
            },
            isAnoFinalValid() {
                return this.anoFinal && this.anoFinal >= this.anoInicial
            },
            download(filename, text) {
                const element = document.createElement('a');
                element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
                element.setAttribute('download', filename);

                element.style.display = 'none';
                document.body.appendChild(element);

                element.click();

                document.body.removeChild(element);
            },
            consultar() {
                this.submitted = true
                this.loaded = false
                this.resultados = []

                if (!this.isProdutoValid() || !this.isMunicipioValid() || !this.isAnoInicialValid() || !this.isAnoFinalValid()) {
                    return
                }

                this.$http.post('relatorio/gerar', {
                    "tipo": "serie",
                    "produto": this.produto.id,
                    "municipios": this.municipiosSelecionados.map(opcao => opcao.municipio.id),
                    "ano_inicial": this.anoInicial,
                    "ano_final": this.anoFinal,
                    "periodo": this.periodo,
                })
                    .then(data => data.json())
                    .then(data => {
                        this.loaded = true
                        this.resultados = data.data

                        if (this.resultados.length && this.tipo === 'csv') {
                            let csv = Object.keys(this.resultados[0]).join(';') + '\n' + this.resultados.map(item => {
                                return Object.values(item).join(';')
                            }).join('\n');

                            this.download('relatorio.csv', csv)
                        }
                    })
                    .catch(error => {
                        console.error(error)
                    })
            },
        },
        components: {
            multiSelect,
        },
    }
</script>
